import argparse

from .archive_generator import ArchiveLinker, DEXES

from flask import Flask, redirect, request
app = Flask(__name__)

## Wiki redirector
@app.route("/wiki/<path:path>")
def redirect_wiki (path):
    return redirect(make_wiki_url(path))

def make_wiki_url (path):
    url = app.args.wiki_archive

    if path.endswith("/"):
        path = path[:-1]

    if not url.endswith("/"):
        url = url + "/"

    return url + app.wiki_linker.translate_page_title(path)

## Forum redirector
@app.route('/forums/<path:path>')
def redirect_forums (path):
    return redirect(make_forum_url(path))

def make_forum_url (request):
    return str(request)

def main ():
    parser = argparse.ArgumentParser()
    parser.add_argument("--wiki-archive",  help="URL to wiki archive")
    parser.add_argument("--forums-archive",  help="URL to forums archive")

    app.args = parser.parse_args()
    app.wiki_linker = ArchiveLinker(directory_names=DEXES)
    app.run()